/***************************************************************************
                          knmapdata.cpp  -  description
                             -------------------
    begin                : Thu May 25 2000
    copyright            : (C) 2000 by Alexandre Sagala
    email                : rewind2@videotron.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qsize.h>
#include <kiconloader.h>

#include <iostream.h>

#include <kapp.h>
#include "knmap.h"

void KNmap::initGUI()
{

	int height = kapp->getConfig()->readNumEntry("winh",600);
	int width = kapp->getConfig()->readNumEntry("winw",550);

   this->setMinimumSize(550,600);

   QSize s (width,height);

  /*if (s.width() * 3 > KApplication::desktop()->width() * 2 )
   	s.setWidth(KApplication::desktop()->width() * 2);

   if (s.height() * 3 > KApplication::desktop()->height() * 2 )
   	s.setHeight(KApplication::desktop()->height() * 2 / 3);   		
   else if (s.height() * 2 < KApplication::desktop()->height())
		s.setHeight(KApplication::desktop()->height() / 2);
   */
		
	resize(s);
		
	this->setCaption("KNmap: KDE frontend for Nmap");
	
	QWidget *frame = new QWidget(this);	
	
   lblHost= new QLabel(frame,"lblHost");
   lblHost->setText(i18n("Host(s):"));
   lblHost->setMaximumSize(lblHost->sizeHint());

   groupScan= new QButtonGroup(frame,"groupScan");
   groupScan->setTitle(i18n("Scan Types"));

	QHBoxLayout *hlayoutScan = new QHBoxLayout(groupScan, groupScan->frameWidth());
	QVBoxLayout *vlayoutScan = new QVBoxLayout();	
	
	hlayoutScan->addLayout(vlayoutScan);

   vlayoutScan->addSpacing( groupScan->fontMetrics().height());

   optTcp= new QRadioButton(groupScan,"optTcp");
   optTcp->setText(i18n("TCP scan  "));
   optTcp->setChecked(true);
   optTcp->setMaximumWidth( optTcp->sizeHint().width());
   vlayoutScan->addWidget( optTcp );

   optSyn= new QRadioButton(groupScan,"optSyn");
   optSyn->setText(i18n("SYN scan"));
   optSyn->setMaximumWidth( optTcp->sizeHint().width());
   vlayoutScan->addWidget( optSyn );

   optNull= new QRadioButton(groupScan,"optNull");
   optNull->setText(i18n("Null scan"));
   optNull->setMaximumWidth( optTcp->sizeHint().width());
   vlayoutScan->addWidget( optNull );

   optFin= new QRadioButton(groupScan,"optFin");
   optFin->setText(i18n("FIN scan"));
   optFin->setMaximumWidth( optTcp->sizeHint().width());
   vlayoutScan->addWidget( optFin );

   optXmas= new QRadioButton(groupScan,"optXmas");
   optXmas->setText(i18n("Xmas scan"));
   optXmas->setMaximumWidth( optTcp->sizeHint().width() );
   vlayoutScan->addWidget( optXmas );

   optPingSweep= new QRadioButton(groupScan,"optPingSweep");
   optPingSweep->setText(i18n("Ping sweep"));
   optPingSweep->setMaximumWidth( optTcp->sizeHint().width());
   vlayoutScan->addWidget( optPingSweep );

   optUdp= new QRadioButton(groupScan,"optUdp");
   optUdp->setText(i18n("UDP scan"));
   optUdp->setMaximumWidth( optTcp->sizeHint().width());
   vlayoutScan->addWidget( optUdp );
	
   groupScan->setMaximumSize( groupScan->childrenRect().size());
	
   cboHost= new QComboBox(true,frame,"cboHost");
   cboHost->setMaximumHeight( cboHost->sizeHint().height() );
   cboHost->setMinimumWidth( cboHost->sizeHint().width() );
   cboHost->insertItem("");
   cboHost->setFocus();
   // @TODO modifier ca
   cboHost->setMaxCount (25 );

   groupOptions= new QButtonGroup(frame,"groupOptions");
   groupOptions->setTitle(i18n("Others"));

	QGridLayout *optlayout = new QGridLayout(groupOptions,8,5,groupScan->frameWidth()+11,groupScan->frameWidth()+3);

	optlayout->setColStretch(0,2);
	optlayout->setColStretch(1,0);
	optlayout->setColStretch(2,2);		
	optlayout->setColStretch(3,0);	
	optlayout->setColStretch(4,2);	
	
	optlayout->addRowSpacing(0,5);
	
	optlayout->setRowStretch(0,0);
	optlayout->setRowStretch(1,1);
	optlayout->setRowStretch(2,1);		
	optlayout->setRowStretch(3,1);	
	optlayout->setRowStretch(4,1);	
	optlayout->setRowStretch(5,1);
	optlayout->setRowStretch(6,1);	
	optlayout->setRowStretch(7,1);
	
   chkRandom= new QCheckBox(groupOptions,"chkRandom");
   chkRandom->setText(i18n("No random  "));
   chkRandom->setMaximumWidth( chkRandom->sizeHint().width() );
   optlayout->addWidget( chkRandom,6,0);	
					
   chkFastScan= new QCheckBox(groupOptions,"chkFastScan");
   chkFastScan->setText(i18n("Fast Scan"));
   chkFastScan->setMaximumWidth( chkRandom->sizeHint().width() );
   optlayout->addWidget( chkFastScan,1,0);

   chkIdentd= new QCheckBox(groupOptions,"chkIdentd");
   chkIdentd->setText(i18n("Identd Info"));
   chkIdentd->setMaximumWidth( chkRandom->sizeHint().width() );
   optlayout->addWidget( chkIdentd,2,0);

   chkFragment= new QCheckBox(groupOptions,"chkFragment");
   chkFragment->setText(i18n("Fragment"));
 	chkFragment->setEnabled(false);
   chkFragment->setMaximumWidth( chkRandom->sizeHint().width() );
   optlayout->addWidget( chkFragment,3,0);

   chkOs= new QCheckBox(groupOptions,"chkOs");
   chkOs->setText(i18n("OS Detection"));
   chkOs->setMaximumWidth( chkRandom->sizeHint().width() );
   optlayout->addWidget( chkOs,4,0);

   chkBounce= new QCheckBox(groupOptions,"chkBounce");
   chkBounce->setText(i18n("FTP bounce"));
   chkBounce->setMaximumWidth( chkRandom->sizeHint().width() );
   optlayout->addWidget( chkBounce,5,0 );
	
   chkRpc= new QCheckBox(groupOptions,"chkRpc");
   chkRpc->setText(i18n("RPC  Check"));
   chkRpc->setMaximumWidth( chkRandom->sizeHint().width() );
   optlayout->addWidget( chkRpc,7,0 );

   lblPort= new QLabel(groupOptions,"lblPort");
   lblPort->setText(i18n("Port Range:"));
   lblPort->setMaximumWidth( lblPort->sizeHint().width() );
   optlayout->addWidget( lblPort,7,2);

   lblDecoy= new QLabel(groupOptions,"lblDecoy");
   lblDecoy->setText(i18n("Decoy(s):"));
   lblDecoy->setMaximumWidth( lblPort->sizeHint().width() );
   optlayout->addWidget( lblDecoy,1,2 );
	
   cmdAdd= new QPushButton(groupOptions,"cmdAdd");
   cmdAdd->setText(i18n("Add"));
   cmdAdd->setMaximumWidth( lblPort->sizeHint().width() );
   optlayout->addWidget( cmdAdd,2,2 );

   cmdDel= new QPushButton(groupOptions,"cmdDel");
   cmdDel->setText(i18n("Del"));
	cmdDel->setEnabled(false);
   cmdDel->setMaximumWidth( lblPort->sizeHint().width() );
   optlayout->addWidget( cmdDel,3,2 );

   lblTiming= new QLabel(groupOptions,"lblTiming");
   lblTiming->setText(i18n("Timing:"));
   lblTiming->setMaximumWidth( lblPort->sizeHint().width() );
   optlayout->addWidget( lblTiming,4,2 );

   lblPing= new QLabel(groupOptions,"lblPing");
   lblPing->setText(i18n("Ping Type:"));
   lblPing->setMaximumWidth( lblPort->sizeHint().width() );
   optlayout->addWidget( lblPing,5,2 );

   lblResolve= new QLabel(groupOptions,"lblResolve");
   lblResolve->setText(i18n("Resolve:"));
   lblResolve->setMaximumWidth( lblPort->sizeHint().width() );
   optlayout->addWidget( lblResolve,6,2 );

   lstDecoy= new QListBox(groupOptions,"lstDecoy");
   optlayout->addMultiCellWidget( lstDecoy,2,3,4,4 );

   cboTiming= new QComboBox(groupOptions,"cboTiming");
   cboTiming->insertItem(i18n("Paranoid"));
   cboTiming->insertItem(i18n("Sneaky"));
   cboTiming->insertItem(i18n("Polite"));
   cboTiming->insertItem(i18n("Normal"));
   cboTiming->insertItem(i18n("Agressive"));
   cboTiming->insertItem(i18n("Insane"));
 	cboTiming->setCurrentItem(3);	// Normal
   optlayout->addWidget( cboTiming,4,4 );

   txtDecoy= new QLineEdit(groupOptions,"txtDecoy");
   optlayout->addWidget( txtDecoy,1,4 );

   cboPing= new QComboBox(groupOptions,"cboPing");
   cboPing->insertItem(i18n("Don't Ping"));
   cboPing->insertItem(i18n("TCP Ping"));
   cboPing->insertItem(i18n("SYN Ping"));
   cboPing->insertItem(i18n("ICMP Ping"));
   cboPing->insertItem(i18n("TCP & ICMP"));
   cboPing->setCurrentItem(4); //TCP & ICMP
   optlayout->addWidget( cboPing,5,4 );

   cboResolve= new QComboBox(groupOptions,"cboResolve");
   cboResolve->insertItem(i18n("Always"));
   cboResolve->insertItem(i18n("Sometimes"));
   cboResolve->insertItem(i18n("Never"));
   cboResolve->setCurrentItem(1); // Sometimes
   optlayout->addWidget( cboResolve,6,4 );

   txtPort= new QLineEdit(groupOptions,"txtPort");
   optlayout->addWidget( txtPort,7,4);

   optlayout->addColSpacing (0,chkRandom->sizeHint().width());
   optlayout->addColSpacing (1,3);
   optlayout->addColSpacing (3,3);	

   cmdInput= new QPushButton(frame,"cmdInput");
   cmdInput->setPixmap(Icon("fileopen.xpm"));
   cmdInput->setMaximumSize(cmdInput->sizeHint());

   txtResult= new QMultiLineEdit(frame,"txtResult");
	txtResult->setMinimumHeight(200);

   cmdScan= new QPushButton(frame,"cmdScan");
   cmdScan->setText(i18n("&Scan"));
   cmdScan->setMinimumWidth( cmdScan->sizeHint().width());
	cmdScan->setMaximumHeight(cmdScan->sizeHint().height()+5);

   cmdQuit= new QPushButton(frame,"cmdQuit");
   cmdQuit->setText(i18n("&Quit"));
   cmdQuit->setMinimumWidth( cmdQuit->sizeHint().width());
	cmdQuit->setMaximumHeight(cmdQuit->sizeHint().height()+5);
	
   cmdCancel= new QPushButton(frame,"cmdCancel");
   cmdCancel->setText(i18n("&Cancel"));
   cmdCancel->setMinimumWidth( cmdQuit->sizeHint().width());
	cmdCancel->setMaximumHeight(cmdCancel->sizeHint().height()+5);

	glayout = new QGridLayout(frame,4,1,5,10);
	glayout->setRowStretch(0,0);	// cboHost
	glayout->setRowStretch(1,1);  // options
	glayout->setRowStretch(2,2);	// txtResult	
	glayout->setRowStretch(3,0);	// commands

   hlayoutTop = new QHBoxLayout();
   hlayoutButtons = new QHBoxLayout();
   hlayoutHost = new QHBoxLayout();
   hlayoutMiddle = new QHBoxLayout();

   glayout->addLayout(hlayoutHost,0,0);
   glayout->addLayout(hlayoutTop,1,0);
   glayout->addLayout(hlayoutMiddle,2,0);
   glayout->addLayout(hlayoutButtons,3,0);

   hlayoutHost->addSpacing (6);
   hlayoutHost->addWidget(lblHost,1);
   hlayoutHost->addWidget(cboHost,2);
   hlayoutHost->addWidget(cmdInput,1);
   hlayoutHost->addSpacing (6);

   hlayoutTop->addSpacing (5);
   hlayoutTop->addWidget(groupScan,2);
   hlayoutTop->addWidget(groupOptions,3);
   hlayoutTop->addSpacing (5);
	
   hlayoutMiddle->addSpacing (5);
	hlayoutMiddle->addWidget(txtResult);
   hlayoutMiddle->addSpacing (5);

   QLabel *filler= new QLabel(frame);
   filler->setMinimumWidth(this->width()/8);
   filler->setMinimumHeight(cmdCancel->sizeHint().height());

   hlayoutButtons->addSpacing (5);
   hlayoutButtons->addWidget(filler,1);
   hlayoutButtons->addWidget(cmdScan,1);
   hlayoutButtons->addSpacing (5);
   hlayoutButtons->addWidget(cmdCancel,1);
   hlayoutButtons->addSpacing (5);
   hlayoutButtons->addWidget(cmdQuit,1);
   hlayoutButtons->addWidget(filler,1);
   hlayoutButtons->addSpacing (5);
		
	glayout->addRowSpacing (0,cboHost->sizeHint().height());
	glayout->addRowSpacing (1,200);	
	//glayout->addRowSpacing (2,100);
	glayout->addRowSpacing (3,cmdCancel->sizeHint().height());

  	glayout->activate();
  	
  	setView(frame);
	
}
