/***************************************************************************
                          wordwrap.cpp  -  description
                             -------------------
    begin                : Thu Jun 1 2000
    copyright            : (C) 2000 by Alexandre Sagala
    email                : rewind2@videotron.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "wordwrap.h"

/*
/////////////////////////////////////////////////////////////////////////////////////////
//  Word Wrap - builds a string to display in a QMultiLineEdit in wrapped fashion.
//
//  Usage:
//    WordWrap wwrap( text for display, width of the QMultiLineEdit minus a space value );
//    QMultiLineEdit->clear();
//    QMultiLineEdit->insertLine( wwrap.wrapString() );
/////////////////////////////////////////////////////////////////////////////////////////
*/
WordWrap::WordWrap(QString str,int width)
{
  list_str = str.copy();
  list_width = width/7;
}

WordWrap::~WordWrap()
{}

QString WordWrap::wrapString()
{
  if ((int)list_str.length() <= list_width) {
    return list_str;
  }

  QString retstr = "";
  int last;

  while ((int)list_str.length() > list_width) {

    last = list_str.findRev(' ',list_width);
    if (last >= 0) {
      retstr.append(list_str.mid(0,last));
    } else {
      last = list_width-2;
      retstr.append(list_str.mid(0,last));
      retstr.append(CONTINUE_CHAR);
    }

    retstr.append(NEWLINE_CHAR);
    list_str.remove(0,last+1);
  }

  retstr.append(list_str);
  return retstr;
}